package jp.hishidama.asakusafw.dsl3

class DataSource

class DataSources[
  D1<:DataSource,
  D2<:DataSource,
  D3<:DataSource,
  D4<:DataSource,
  D5<:DataSource,
  D6<:DataSource,
  D7<:DataSource
](
  val ds1:D1,
  val ds2:D2,
  val ds3:D3 = null,
  val ds4:D4 = null,
  val ds5:D5 = null,
  val ds6:D6 = null,
  val ds7:D7 = null
) extends DataSource {
}

private[dsl3] class NullDataSource extends DataSource
private[dsl3] object NullDataSource extends NullDataSource

class Operation[
  I1<:DataSource,
  I2<:DataSource,
  I3<:DataSource,
  O1<:DataSource,
  O2<:DataSource,
  O3<:DataSource
](
  val i1:I1,
  val i2:I2 = NullDataSource,
  val i3:I3 = NullDataSource)(
  val o1:O1,
  val o2:O2 = NullDataSource,
  val o3:O3 = NullDataSource
) {
  implicit def nop:Unit = {}
  def apply[A1<:I1, A2<:I2, A3<:I3](i1:A1, i2:A2 = NullDataSource, i3:A3 = NullDataSource) = this

  var out1:O1 = o1
  var out2:O2 = o2
  var out3:O3 = o3
}



abstract class Flow[
  I1<:DataSource,
  I2<:DataSource,
  I3<:DataSource,
  O1<:DataSource,
  O2<:DataSource,
  O3<:DataSource
](
  val in1: I1,
  val in2 :I2 = NullDataSource,
  val in3 :I3 = NullDataSource)(
  val out1:O1,
  val out2:O2 = NullDataSource,
  val out3:O3 = NullDataSource
) {
  val flow = this

  def start(f: =>Unit) = f
}







object d׃f[^ extends DataSource
object dԕif[^ extends DataSource
object pUփf[^ extends DataSource
object ύXf[^ extends DataSource

object C݌ɐUTRN extends DataSource
object CvTRN extends DataSource
object C݌ɈړTRN extends DataSource
object vTRN extends DataSource

object dTRN extends DataSource
object ݌ɐUTRN extends DataSource
object ݌ɈړTRN extends DataSource
object vTRN extends DataSource

object vώdTRN extends DataSource
object vϖvTRN extends DataSource
object vϖpTRN extends DataSource
object XVϔ|cTRN extends DataSource

object G[TRN extends DataSource
object xsTRN extends DataSource
object xTRN extends DataSource
object ƍώxpTRN extends DataSource
object ƍϖvTRN extends DataSource
object ƍώdTRN extends DataSource
object ƍϐTRN extends DataSource

object df[^ extends DataSources(d׃f[^, dԕif[^, pUփf[^, ύXf[^)
object Cf[^ extends DataSources(C݌ɐUTRN, CvTRN, C݌ɈړTRN, vTRN)
object ύX݌ɕύXTRN extends DataSource
object df[^TRN extends DataSources(dTRN, ݌ɐUTRN, ݌ɈړTRN, vTRN)
object cXVTRN extends DataSources(vώdTRN, vϖvTRN, vϖpTRN, XVϔ|cTRN)
object TRN extends DataSource
object vf[^TRN extends DataSources(G[TRN, xsTRN, xTRN,
                                        ƍώxpTRN, ƍϖvTRN,
                                        ƍώdTRN, ƍϐTRN)


case object df[^荞 extends Operation(df[^)(df[^TRN, ύX݌ɕύXTRN)
case object cXV extends Operation(df[^TRN, Cf[^)(cXVTRN)
case object ƍ extends Operation(cXVTRN, TRN)(vf[^TRN)
//case object ƍ extends Operation(TRN,cXVTRN)(vf[^TRN) /*NGp^[*/

object vob` extends Flow(df[^, Cf[^, TRN)(vf[^TRN, ύX݌ɕύXTRN) {
  start {
    val df[^荞flow = df[^荞(flow.in1)
    df[^荞flow.out2 = flow.out2

    val cXVflow = cXV(df[^荞flow.out1, flow.in2)

    val ƍflow = ƍ(cXVflow.out1, flow.in3)
    ƍflow.out1 = flow.out1
  }
}



